﻿//////////////////////////////////////////////////////////////////////////////
//
//  Copyright © Lavernock Enterprises 2007. All rights reserved.
//
//  www.lavernockenterprises.co.uk
//
//////////////////////////////////////////////////////////////////////////////

window.attachEvent ("onload", DoLoad);

// Settings
var setting_pwd_length_random;
var setting_pwd_length_specify;
var setting_pwd_length;
var setting_char_type_upper;
var setting_char_type_lower;
var setting_char_type_numeric;
var setting_char_type_punctuation;

var num_disallowed = 0;
var num_upper = 0;
var num_lower = 0;
var num_digit = 0;
var num_punct = 0;
var pwd_length = 0;
var pwd_strength = 0;
var min_pwd_strength = 4;
var timeout1 = 0;
var timeout2 = 0;

function DoLoad ()
{
	window.detachEvent ("onload", DoLoad);
	window.attachEvent ("onunload", DoUnload);

	id_background.softedge = 1;

	// Add settings capability
	System.Gadget.settingsUI = "Settings.html";
	System.Gadget.onSettingsClosed = SettingsClosed;

	ReadSettings ();
	
	document.getElementById ("pwdbtn").onclick = pwdbtn_Click;
	document.getElementById ("pwdtest").onpropertychange = pwdtest_Change;
	document.getElementById ("frm_pwdtest").onsubmit = frm_pwdtest_Submit;
}

function DoUnload ()
{
	window.detachEvent ("onunload", DoUnload);
	clearTimeout (timeout1);
	clearTimeout (timeout2);
}

function ReadSettings ()
{
	if (System.Gadget.Settings.read ("SavedSettings"))
	{
		setting_pwd_length_random = System.Gadget.Settings.read ("pwd_length_random");
		setting_pwd_length_specify = System.Gadget.Settings.read ("pwd_length_specify");
		setting_pwd_length = System.Gadget.Settings.read ("pwd_length");
		setting_char_type_upper = System.Gadget.Settings.read ("char_type_upper");
		setting_char_type_lower = System.Gadget.Settings.read ("char_type_lower");
		setting_char_type_numeric = System.Gadget.Settings.read ("char_type_numeric");
		setting_char_type_punctuation = System.Gadget.Settings.read ("char_type_punctuation");
	}
	else
	{
		setting_pwd_length_random = default_pwd_length_random;
		setting_pwd_length_specify = default_pwd_length_specify;
		setting_pwd_length = default_pwd_length;
		setting_char_type_upper = default_char_type_upper;
		setting_char_type_lower = default_char_type_lower;
		setting_char_type_numeric = default_char_type_numeric;
		setting_char_type_punctuation = default_char_type_punctuation;
	}	
	
	min_pwd_strength = 0;
	min_pwd_strength += setting_char_type_upper ? 1 : 0;
	min_pwd_strength += setting_char_type_lower ? 1 : 0;
	min_pwd_strength += setting_char_type_numeric ? 1 : 0;
	min_pwd_strength += setting_char_type_punctuation ? 1 : 0;
}

function SettingsClosed (event)
{
	if (event.closeAction == event.Action.commit)
	{
		ReadSettings ();
	}
}

function pwdbtn_Click ()
{
	this.value = GeneratePassword ();
	TestPassword (this.value);
	UpdateFeedback ();
	clearTimeout (timeout1);
	timeout1 = setTimeout (pwdbtn_Reset, 60000);
	window.event.returnValue = false;
	return false;
}

function pwdbtn_Reset ()
{
	document.getElementById ("pwdbtn").value = "New password";
}

function pwdtest_Change ()
{
	clearTimeout (timeout2);
	timeout2 = setTimeout (pwdtest_Reset, 60000);
	window.event.returnValue = false;
	return false;
}

function pwdtest_Reset ()
{
	document.getElementById ("pwdtest").value = "       ";
}

function frm_pwdtest_Submit (e)
{
	var obj = document.getElementById ("pwdtest");
	TestPassword (obj.value);
	obj.value = "       ";
	UpdateFeedback ();
	window.event.returnValue = false;
	return false;
}

function GeneratePassword ()
{
	var str_password = "";
	var str_allowable_chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyz0123456789012345678901234567890123456789~!@#$%^&*()_+-={}|[]\\:\";'<>?,./£`¬";
	var x;
	var ch;

	var attempts = 0;
	var i = 0;

	if (setting_pwd_length_random)
	{
		pwd_length = parseInt (Math.random () * 9 + 8, 10);
	}
	else if (setting_pwd_length_specify)
	{
		pwd_length = setting_pwd_length;
	}
	else
	{
		pwd_length = default_pwd_length;
	}

	do
	{
		str_password = "";
		num_upper = 0;
		num_lower = 0;
		num_digit = 0;
		num_punct = 0;
		pwd_strength = 0;
		
		for (i = 0; i < pwd_length; i++)
		{
			var b_continue = false;
			do
			{
				b_continue = false;
				x = parseInt (Math.random () * str_allowable_chars.length, 10);
				ch = str_allowable_chars.charAt (x);
				if (str_password.indexOf (ch) >= 0)
				{
					b_continue = true;
				}
				else if (!setting_char_type_upper && /[A-Z]/.test (ch))
				{
					b_continue = true;
				}
				else if (!setting_char_type_lower && /[a-z]/.test (ch))
				{
					b_continue = true;
				}
				else if (!setting_char_type_numeric && /[0-9]/.test (ch))
				{
					b_continue = true;
				}
				else if (!setting_char_type_punctuation && /[^A-Za-z0-9]/.test (ch))
				{
					b_continue = true;
				}
			}
			while (b_continue);
			
			str_password += ch;
			if (/[A-Z]/.test (str_password.charAt (i)))
			{
				num_upper++;
			}
			if (/[a-z]/.test (str_password.charAt (i)))
			{
				num_lower++;
			}
			if (/[0-9]/.test (str_password.charAt (i)))
			{
				num_digit++;
			}
			if (/[^A-Za-z0-9]/.test (str_password.charAt (i)))
			{
				num_punct++;
			}
		}

		if (num_upper)
		{
			pwd_strength++;
		}
		if (num_lower)
		{
			pwd_strength++;
		}
		if (num_digit)
		{
			pwd_strength++;
		}
		if (num_punct)
		{
			pwd_strength++;
		}
	}
	while ((pwd_strength < min_pwd_strength));// && (++attempts < 11));

	return str_password;
}

function TestPassword (str_password)
{
	var i;
	
	var re_disallowed_chars = /[^A-Za-z0-9~!@#\$%\^&\*\(\)_\+-=\{\}\|\[\]\\:";'<>\?,\.\/£`¬]/;

	num_disallowed = 0;
	num_upper = 0;
	num_lower = 0;
	num_digit = 0;
	num_punct = 0;
	pwd_length = str_password.length;
	pwd_strength = 0;

	for (i = 0; i < pwd_length; i++)
	{
		ch = str_password.charAt (i);

		if (re_disallowed_chars.test (ch))
		{
			num_disallowed++;
		}
		else if (/[A-Z]/.test (ch))
		{
			num_upper++;
		}
		else if (/[a-z]/.test (ch))
		{
			num_lower++;
		}
		else if (/[0-9]/.test (ch))
		{
			num_digit++;
		}
		else if (/[^A-Za-z0-9]/.test (ch))
		{
			num_punct++;
		}
	}
	
	if (num_upper)
	{
		pwd_strength++;
	}
	if (num_lower)
	{
		pwd_strength++;
	}
	if (num_digit)
	{
		pwd_strength++;
	}
	if (num_punct)
	{
		pwd_strength++;
	}
}
	
function UpdateFeedback ()
{
	var obj;
	
	obj = document.getElementById ("fb_upper");
	obj.innerText = num_upper;
	obj = document.getElementById ("fb_lower");
	obj.innerText = num_lower;
	obj = document.getElementById ("fb_digit");
	obj.innerText = num_digit;
	obj = document.getElementById ("fb_punct");
	obj.innerText = num_punct;
	obj = document.getElementById ("fb_length");
	obj.innerText = pwd_length;
	if (pwd_length < 8 || pwd_length > 16)
	{
		obj.className = "fb weak";
	}
	else
	{
		obj.className = "fb strong";
	}
	obj = document.getElementById ("fb_strength");
	obj.innerText = pwd_strength;
	if (pwd_strength < 3)
	{
		obj.className = "fb weak";
	}
	else
	{
		obj.className = "fb strong";
	}
	obj = document.getElementById ("fb_disallowed");
	obj.innerText = num_disallowed;
	if (num_disallowed)
	{
		obj.className = "fb weak";
	}
	else
	{
		obj.className = "fb strong";
	}

	return false;
}
