﻿//////////////////////////////////////////////////////////////////////////////
//
//  Copyright © Lavernock Enterprises 2007. All rights reserved.
//
//  www.lavernockenterprises.co.uk
//
//////////////////////////////////////////////////////////////////////////////

window.attachEvent ("onload", DoLoad);

function DoLoad ()
{
	window.detachEvent ("onload", DoLoad);
	window.attachEvent ("onunload", DoUnload);
	System.Gadget.onSettingsClosing = SettingsClosing;
	
	if (System.Gadget.Settings.read ("SavedSettings"))
	{
		// Initialise random password length radio
		id_pwd_length_random.checked = System.Gadget.Settings.read ("pwd_length_random");
		
		// Initialise specific password length radio
		id_pwd_length_specify.checked = System.Gadget.Settings.read ("pwd_length_specify");
		
		// Initialise password length textbox
		id_pwd_length.value = System.Gadget.Settings.read ("pwd_length");
		
		// Initialise char type UPPER textbox
		id_char_type_upper.checked = System.Gadget.Settings.read ("char_type_upper");
		
		// Initialise char type lower textbox
		id_char_type_lower.checked = System.Gadget.Settings.read ("char_type_lower");
		
		// Initialise char type numeric textbox
		id_char_type_numeric.checked = System.Gadget.Settings.read ("char_type_numeric");
		
		// Initialise char type punctuation textbox
		id_char_type_punctuation.checked = System.Gadget.Settings.read ("char_type_punctuation");
	}
	else
	{
		ResetDefaults ();
	}
	
	id_pwd_length_random.focus ();
	id_pwd_length_specify.onpropertychange = id_pwd_length_specify_OnPropertyChange;
	id_btn_reset_defaults.onclick = ResetDefaults;
}

function DoUnload ()
{
	window.detachEvent ("onunload", DoUnload);
}

function SettingsClosing (event)
{
	if (event.closeAction == event.Action.commit)
	{
		var b_error = false;
		
		var char_type_count = 0;
		id_char_type_upper.checked ? char_type_count++ : false;
		id_char_type_lower.checked ? char_type_count++ : false;
		id_char_type_numeric.checked ? char_type_count++ : false;
		id_char_type_punctuation.checked ? char_type_count++ : false;
		if (char_type_count < 3)
		{
			id_char_type_upper.focus ();
			id_char_type_head.className = "error";
			b_error = true;
		}
		else
		{
			id_char_type_head.className = "";
		}
		
		var pwd_length = isNaN (parseInt (id_pwd_length.value, 10)) ? 0 : parseInt (id_pwd_length.value, 10);
		if (id_pwd_length_specify.checked && (pwd_length < 8 || pwd_length > 16))
		{
			id_pwd_length.focus ();
			id_pwd_length.select ();
			id_hint_pwd_length.className = "error";
			b_error = true;
		}
		else
		{
			id_hint_pwd_length.className = "";
		}
		
		if (b_error)
		{
			event.cancel = true;
			return;
		}
			
		System.Gadget.Settings.write ("pwd_length_random", id_pwd_length_random.checked);
		System.Gadget.Settings.write ("pwd_length_specify", id_pwd_length_specify.checked);
		System.Gadget.Settings.write ("pwd_length", pwd_length);
		System.Gadget.Settings.write ("char_type_upper", id_char_type_upper.checked);
		System.Gadget.Settings.write ("char_type_lower", id_char_type_lower.checked);
		System.Gadget.Settings.write ("char_type_numeric", id_char_type_numeric.checked);
		System.Gadget.Settings.write ("char_type_punctuation", id_char_type_punctuation.checked);
		
		System.Gadget.Settings.write ("SavedSettings", true);

		event.cancel = false;
	}
}

function ResetDefaults ()
{
	// Reset Password Length fieldset
	id_pwd_length_random.checked = default_pwd_length_random;
	id_pwd_length_specify.checked = default_pwd_length_specify;
	id_pwd_length.value = default_pwd_length;
	id_hint_pwd_length.className = "";

	// Reset Character Types fieldset
	id_char_type_head.className = "";
	id_char_type_upper.checked = default_char_type_upper;
	id_char_type_lower.checked = default_char_type_lower;
	id_char_type_numeric.checked = default_char_type_numeric;
	id_char_type_punctuation.checked = default_char_type_punctuation;
}

function id_pwd_length_specify_OnPropertyChange ()
{
	if (id_pwd_length_specify.checked)
	{
		id_pwd_length.disabled = false;
		id_hint_pwd_length.disabled = false;
	}
	else
	{
		id_pwd_length.disabled = true;
		id_hint_pwd_length.disabled = true;
	}
}